package com.hotwj.platform.driverManagement.driverGroup.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.driverManagement.driverGroup.domain.HotDriverGroup;
import com.hotwj.platform.driverManagement.driverGroup.domain.bo.HotDriverGroupBo;
import com.hotwj.platform.driverManagement.driverGroup.domain.vo.HotDriverGroupVo;
import com.hotwj.platform.driverManagement.driverGroup.mapper.HotDriverGroupMapper;
import com.hotwj.platform.driverManagement.driverGroup.service.IHotDriverGroupService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 驾驶员分组Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-16
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotDriverGroupServiceImpl implements IHotDriverGroupService {

    private final HotDriverGroupMapper baseMapper;

    /**
     * 查询驾驶员分组
     *
     * @param id 主键
     * @return 驾驶员分组
     */
    @Override
    public HotDriverGroupVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询驾驶员分组列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 驾驶员分组分页列表
     */
    @Override
    public TableDataInfo<HotDriverGroupVo> queryPageList(HotDriverGroupBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotDriverGroup> lqw = buildQueryWrapper(bo);
        Page<HotDriverGroupVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的驾驶员分组列表
     *
     * @param bo 查询条件
     * @return 驾驶员分组列表
     */
    @Override
    public List<HotDriverGroupVo> queryList(HotDriverGroupBo bo) {
        LambdaQueryWrapper<HotDriverGroup> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotDriverGroup> buildQueryWrapper(HotDriverGroupBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotDriverGroup> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotDriverGroup::getId);
        lqw.eq(bo.getCompanyId() != null, HotDriverGroup::getCompanyId, bo.getCompanyId());
        lqw.like(StringUtils.isNotBlank(bo.getGroupName()), HotDriverGroup::getGroupName, bo.getGroupName());
        lqw.eq(bo.getLeaderId() != null, HotDriverGroup::getLeaderId, bo.getLeaderId());
        lqw.like(StringUtils.isNotBlank(bo.getLeaderName()), HotDriverGroup::getLeaderName, bo.getLeaderName());
        lqw.eq(StringUtils.isNotBlank(bo.getMemberIds()), HotDriverGroup::getMemberIds, bo.getMemberIds());
        lqw.eq(bo.getIsDeleted() != null, HotDriverGroup::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增驾驶员分组
     *
     * @param bo 驾驶员分组
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotDriverGroupBo bo) {
        HotDriverGroup add = MapstructUtils.convert(bo, HotDriverGroup.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改驾驶员分组
     *
     * @param bo 驾驶员分组
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotDriverGroupBo bo) {
        HotDriverGroup update = MapstructUtils.convert(bo, HotDriverGroup.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotDriverGroup entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除驾驶员分组信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
